diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/lte/test/test-lte-epc-e2e-data.cc ns-3.40/src/lte/test/test-lte-epc-e2e-data.cc
--- ns-3.39/src/lte/test/test-lte-epc-e2e-data.cc	2023-07-05 14:23:48.029428000 -0700
+++ ns-3.40/src/lte/test/test-lte-epc-e2e-data.cc	2023-09-27 13:30:37.830839600 -0700
@@ -195,13 +195,11 @@
                                      StringValue("RowFirst"));
     enbMobility.Install(enbs);
     NetDeviceContainer enbLteDevs = lteHelper->InstallEnbDevice(enbs);
-    NetDeviceContainer::Iterator enbLteDevIt = enbLteDevs.Begin();
+    auto enbLteDevIt = enbLteDevs.Begin();
 
     uint16_t ulPort = 1000;
 
-    for (std::vector<EnbTestData>::iterator enbit = m_enbTestData.begin();
-         enbit < m_enbTestData.end();
-         ++enbit, ++enbLteDevIt)
+    for (auto enbit = m_enbTestData.begin(); enbit < m_enbTestData.end(); ++enbit, ++enbLteDevIt)
     {
         NS_ABORT_IF(enbLteDevIt == enbLteDevs.End());
 
@@ -317,12 +315,9 @@
 
     uint64_t imsiCounter = 0;
 
-    for (std::vector<EnbTestData>::iterator enbit = m_enbTestData.begin();
-         enbit < m_enbTestData.end();
-         ++enbit)
+    for (auto enbit = m_enbTestData.begin(); enbit < m_enbTestData.end(); ++enbit)
     {
-        for (std::vector<UeTestData>::iterator ueit = enbit->ues.begin(); ueit < enbit->ues.end();
-             ++ueit)
+        for (auto ueit = enbit->ues.begin(); ueit < enbit->ues.end(); ++ueit)
         {
             uint64_t imsi = ++imsiCounter;
             for (uint32_t b = 0; b < ueit->bearers.size(); ++b)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/lte/test/test-lte-rlc-header.cc ns-3.40/src/lte/test/test-lte-rlc-header.cc
--- ns-3.39/src/lte/test/test-lte-rlc-header.cc	2023-07-05 14:23:48.029428000 -0700
+++ ns-3.40/src/lte/test/test-lte-rlc-header.cc	2023-09-27 13:30:37.830839600 -0700
@@ -151,8 +151,7 @@
     LteRlcAmHeader h;
     h.SetControlPdu(LteRlcAmHeader::STATUS_PDU);
     h.SetAckSn(m_ackSn);
-    for (std::list<SequenceNumber10>::iterator it = m_nackSnList.begin(); it != m_nackSnList.end();
-         ++it)
+    for (auto it = m_nackSnList.begin(); it != m_nackSnList.end(); ++it)
     {
         h.PushNack(it->GetValue());
     }
@@ -170,8 +169,7 @@
     SequenceNumber10 ackSn = h2.GetAckSn();
     NS_TEST_ASSERT_MSG_EQ(ackSn, m_ackSn, "deserialized ACK SN differs from test vector");
 
-    for (std::list<SequenceNumber10>::iterator it = m_nackSnList.begin(); it != m_nackSnList.end();
-         ++it)
+    for (auto it = m_nackSnList.begin(); it != m_nackSnList.end(); ++it)
     {
         int nackSn = h2.PopNack();
         NS_TEST_ASSERT_MSG_GT(nackSn, -1, "not enough elements in deserialized NACK list");
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/lte/test/test-lte-rrc.cc ns-3.40/src/lte/test/test-lte-rrc.cc
--- ns-3.39/src/lte/test/test-lte-rrc.cc	2023-07-05 14:23:48.029428000 -0700
+++ ns-3.40/src/lte/test/test-lte-rrc.cc	2023-09-27 13:30:37.830839600 -0700
@@ -321,7 +321,7 @@
     // instead of lteHelper->Attach () and lteHelper->ActivateXxx
 
     // Set AdmitConnectionRequest attribute
-    for (NetDeviceContainer::Iterator it = enbDevs.Begin(); it != enbDevs.End(); ++it)
+    for (auto it = enbDevs.Begin(); it != enbDevs.End(); ++it)
     {
         Ptr<LteEnbRrc> enbRrc = (*it)->GetObject<LteEnbNetDevice>()->GetRrc();
         enbRrc->SetAttribute("AdmitRrcConnectionRequest",
@@ -330,7 +330,7 @@
 
     uint32_t i = 0;
     uint32_t tmax = 0;
-    for (NetDeviceContainer::Iterator it = ueDevs.Begin(); it != ueDevs.End(); ++it)
+    for (auto it = ueDevs.Begin(); it != ueDevs.End(); ++it)
     {
         Ptr<NetDevice> ueDevice = *it;
         Ptr<NetDevice> enbDevice = enbDevs.Get(0);
@@ -494,8 +494,8 @@
                                   m_nBearers,
                                   "wrong num bearers at UE");
 
-            ObjectMapValue::Iterator enbBearerIt = enbDataRadioBearerMapValue.Begin();
-            ObjectMapValue::Iterator ueBearerIt = ueDataRadioBearerMapValue.Begin();
+            auto enbBearerIt = enbDataRadioBearerMapValue.Begin();
+            auto ueBearerIt = ueDataRadioBearerMapValue.Begin();
             while (enbBearerIt != enbDataRadioBearerMapValue.End() &&
                    ueBearerIt != ueDataRadioBearerMapValue.End())
             {
@@ -679,7 +679,7 @@
     // instead of lteHelper->Attach () and lteHelper->ActivateXxx
 
     // Set AdmitConnectionRequest attribute
-    for (NetDeviceContainer::Iterator it = enbDevs.Begin(); it != enbDevs.End(); ++it)
+    for (auto it = enbDevs.Begin(); it != enbDevs.End(); ++it)
     {
         Ptr<LteEnbRrc> enbRrc = (*it)->GetObject<LteEnbNetDevice>()->GetRrc();
         enbRrc->SetAttribute("AdmitRrcConnectionRequest",
@@ -688,7 +688,7 @@
 
     uint32_t i = 0;
     uint32_t tmax = 0;
-    for (NetDeviceContainer::Iterator it = ueDevs.Begin(); it != ueDevs.End(); ++it)
+    for (auto it = ueDevs.Begin(); it != ueDevs.End(); ++it)
     {
         Ptr<NetDevice> ueDevice = *it;
         Ptr<NetDevice> enbDevice = enbDevs.Get(0);
@@ -782,7 +782,7 @@
 
     NS_LOG_FUNCTION(this);
 
-    for (uint32_t useIdealRrc = 0; useIdealRrc <= 1; ++useIdealRrc)
+    for (auto useIdealRrc : {false, true})
     {
         // <----- all times in ms ----------------->
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/lte/test/test-lte-x2-handover.cc ns-3.40/src/lte/test/test-lte-x2-handover.cc
--- ns-3.39/src/lte/test/test-lte-x2-handover.cc	2023-07-05 14:23:48.029428000 -0700
+++ ns-3.40/src/lte/test/test-lte-x2-handover.cc	2023-09-27 13:30:37.830839600 -0700
@@ -17,13 +17,15 @@
  * Author: Nicola Baldo <nbaldo@cttc.es>
  */
 
-#include <ns3/applications-module.h>
 #include <ns3/core-module.h>
 #include <ns3/internet-module.h>
 #include <ns3/lte-module.h>
 #include <ns3/mobility-module.h>
 #include <ns3/network-module.h>
+#include <ns3/packet-sink-helper.h>
+#include <ns3/packet-sink.h>
 #include <ns3/point-to-point-module.h>
+#include <ns3/udp-client-server-helper.h>
 
 using namespace ns3;
 
@@ -274,7 +276,7 @@
     NetDeviceContainer enbDevices;
     enbDevices = m_lteHelper->InstallEnbDevice(enbNodes);
     stream += m_lteHelper->AssignStreams(enbDevices, stream);
-    for (NetDeviceContainer::Iterator it = enbDevices.Begin(); it != enbDevices.End(); ++it)
+    for (auto it = enbDevices.Begin(); it != enbDevices.End(); ++it)
     {
         Ptr<LteEnbRrc> enbRrc = (*it)->GetObject<LteEnbNetDevice>()->GetRrc();
         enbRrc->SetAttribute("AdmitHandoverRequest", BooleanValue(m_admitHo));
@@ -438,7 +440,7 @@
 
     // check initial RRC connection
     const Time maxRrcConnectionEstablishmentDuration = Seconds(0.080);
-    for (NetDeviceContainer::Iterator it = ueDevices.Begin(); it != ueDevices.End(); ++it)
+    for (auto it = ueDevices.Begin(); it != ueDevices.End(); ++it)
     {
         Simulator::Schedule(maxRrcConnectionEstablishmentDuration,
                             &LteX2HandoverTestCase::CheckConnected,
@@ -450,8 +452,7 @@
     // schedule handover events and corresponding checks
 
     Time stopTime = Seconds(0);
-    for (std::list<HandoverEvent>::iterator hoEventIt = m_handoverEventList.begin();
-         hoEventIt != m_handoverEventList.end();
+    for (auto hoEventIt = m_handoverEventList.begin(); hoEventIt != m_handoverEventList.end();
          ++hoEventIt)
     {
         // Teleport the UE between both eNBs just before the handover starts
@@ -567,8 +568,8 @@
                           m_nDedicatedBearers + 1,
                           "wrong num bearers at UE");
 
-    ObjectMapValue::Iterator enbBearerIt = enbDataRadioBearerMapValue.Begin();
-    ObjectMapValue::Iterator ueBearerIt = ueDataRadioBearerMapValue.Begin();
+    auto enbBearerIt = enbDataRadioBearerMapValue.Begin();
+    auto ueBearerIt = ueDataRadioBearerMapValue.Begin();
     while (enbBearerIt != enbDataRadioBearerMapValue.End() &&
            ueBearerIt != ueDataRadioBearerMapValue.End())
     {
@@ -619,7 +620,7 @@
 void
 LteX2HandoverTestCase::SaveStatsAfterHandover(uint32_t ueIndex)
 {
-    for (std::list<BearerData>::iterator it = m_ueDataVector.at(ueIndex).bearerDataList.begin();
+    for (auto it = m_ueDataVector.at(ueIndex).bearerDataList.begin();
          it != m_ueDataVector.at(ueIndex).bearerDataList.end();
          ++it)
     {
@@ -632,7 +633,7 @@
 LteX2HandoverTestCase::CheckStatsAWhileAfterHandover(uint32_t ueIndex)
 {
     uint32_t b = 1;
-    for (std::list<BearerData>::iterator it = m_ueDataVector.at(ueIndex).bearerDataList.begin();
+    for (auto it = m_ueDataVector.at(ueIndex).bearerDataList.begin();
          it != m_ueDataVector.at(ueIndex).bearerDataList.end();
          ++it)
     {
@@ -759,11 +760,9 @@
         "ns3::PfFfMacScheduler",
     };
 
-    for (std::vector<std::string>::iterator schedIt = schedulers.begin();
-         schedIt != schedulers.end();
-         ++schedIt)
+    for (auto schedIt = schedulers.begin(); schedIt != schedulers.end(); ++schedIt)
     {
-        for (int32_t useIdealRrc = 1; useIdealRrc >= 0; --useIdealRrc)
+        for (auto useIdealRrc : {true, false})
         {
             // nUes, nDBearers, helist, name, sched, admitHo, idealRrc
             AddTestCase(new LteX2HandoverTestCase(1,
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/lte/test/test-lte-x2-handover-measures.cc ns-3.40/src/lte/test/test-lte-x2-handover-measures.cc
--- ns-3.39/src/lte/test/test-lte-x2-handover-measures.cc	2023-07-05 14:23:48.029428000 -0700
+++ ns-3.40/src/lte/test/test-lte-x2-handover-measures.cc	2023-09-27 13:30:37.830839600 -0700
@@ -18,13 +18,16 @@
  *          Manuel Requena <manuel.requena@cttc.es>
  */
 
-#include <ns3/applications-module.h>
+#include <ns3/bulk-send-helper.h>
 #include <ns3/core-module.h>
 #include <ns3/internet-module.h>
 #include <ns3/lte-module.h>
 #include <ns3/mobility-module.h>
 #include <ns3/network-module.h>
+#include <ns3/packet-sink-helper.h>
+#include <ns3/packet-sink.h>
 #include <ns3/point-to-point-module.h>
+#include <ns3/udp-client-server-helper.h>
 
 using namespace ns3;
 
@@ -342,7 +345,7 @@
     NetDeviceContainer enbDevices;
     enbDevices = m_lteHelper->InstallEnbDevice(enbNodes);
     stream += m_lteHelper->AssignStreams(enbDevices, stream);
-    for (NetDeviceContainer::Iterator it = enbDevices.Begin(); it != enbDevices.End(); ++it)
+    for (auto it = enbDevices.Begin(); it != enbDevices.End(); ++it)
     {
         Ptr<LteEnbRrc> enbRrc = (*it)->GetObject<LteEnbNetDevice>()->GetRrc();
         enbRrc->SetAttribute("AdmitHandoverRequest", BooleanValue(m_admitHo));
@@ -538,7 +541,7 @@
 
     // check initial RRC connection
     const Time maxRrcConnectionEstablishmentDuration = Seconds(0.080);
-    for (NetDeviceContainer::Iterator it = ueDevices.Begin(); it != ueDevices.End(); ++it)
+    for (auto it = ueDevices.Begin(); it != ueDevices.End(); ++it)
     {
         NS_LOG_FUNCTION(maxRrcConnectionEstablishmentDuration);
         Simulator::Schedule(maxRrcConnectionEstablishmentDuration,
@@ -551,7 +554,7 @@
     // schedule the checkpoint events
 
     Time stopTime = Seconds(0);
-    for (std::list<CheckPointEvent>::iterator checkPointEventIt = m_checkPointEventList.begin();
+    for (auto checkPointEventIt = m_checkPointEventList.begin();
          checkPointEventIt != m_checkPointEventList.end();
          ++checkPointEventIt)
     {
@@ -639,8 +642,8 @@
                           m_nDedicatedBearers + 1,
                           "wrong num bearers at UE");
 
-    ObjectMapValue::Iterator enbBearerIt = enbDataRadioBearerMapValue.Begin();
-    ObjectMapValue::Iterator ueBearerIt = ueDataRadioBearerMapValue.Begin();
+    auto enbBearerIt = enbDataRadioBearerMapValue.Begin();
+    auto ueBearerIt = ueDataRadioBearerMapValue.Begin();
     while (enbBearerIt != enbDataRadioBearerMapValue.End() &&
            ueBearerIt != ueDataRadioBearerMapValue.End())
     {
@@ -675,7 +678,7 @@
 LteX2HandoverMeasuresTestCase::SaveStats(uint32_t ueIndex)
 {
     NS_LOG_FUNCTION(ueIndex);
-    for (std::list<BearerData>::iterator it = m_ueDataVector.at(ueIndex).bearerDataList.begin();
+    for (auto it = m_ueDataVector.at(ueIndex).bearerDataList.begin();
          it != m_ueDataVector.at(ueIndex).bearerDataList.end();
          ++it)
     {
@@ -695,7 +698,7 @@
 {
     NS_LOG_FUNCTION(ueIndex);
     uint32_t b = 1;
-    for (std::list<BearerData>::iterator it = m_ueDataVector.at(ueIndex).bearerDataList.begin();
+    for (auto it = m_ueDataVector.at(ueIndex).bearerDataList.begin();
          it != m_ueDataVector.at(ueIndex).bearerDataList.end();
          ++it)
     {
@@ -770,10 +773,9 @@
         CheckPointEvent(Seconds(25), Seconds(37), checkInterval, 0, 3),
     };
 
-    int32_t useIdealRrc;
     std::string sched = "ns3::PfFfMacScheduler";
     std::string ho = "ns3::A2A4RsrqHandoverAlgorithm";
-    for (useIdealRrc = 1; useIdealRrc >= 0; --useIdealRrc)
+    for (auto useIdealRrc : {true, false})
     {
         // nEnbs, nUes, nDBearers, celist, name, useUdp, sched, ho, admitHo, idealRrc
         AddTestCase(new LteX2HandoverMeasuresTestCase(2,
@@ -878,7 +880,7 @@
     }
 
     sched = "ns3::RrFfMacScheduler";
-    for (useIdealRrc = 1; useIdealRrc >= 0; --useIdealRrc)
+    for (auto useIdealRrc : {true, false})
     {
         // nEnbs, nUes, nDBearers, celist, name, useUdp, sched, admitHo, idealRrc
         AddTestCase(new LteX2HandoverMeasuresTestCase(2,
@@ -918,7 +920,7 @@
 
     ho = "ns3::A3RsrpHandoverAlgorithm";
     sched = "ns3::PfFfMacScheduler";
-    for (useIdealRrc = 1; useIdealRrc >= 0; --useIdealRrc)
+    for (auto useIdealRrc : {true, false})
     {
         // nEnbs, nUes, nDBearers, celist, name, useUdp, sched, admitHo, idealRrc
         AddTestCase(new LteX2HandoverMeasuresTestCase(2,
@@ -957,7 +959,7 @@
     }
 
     sched = "ns3::RrFfMacScheduler";
-    for (useIdealRrc = 1; useIdealRrc >= 0; --useIdealRrc)
+    for (auto useIdealRrc : {true, false})
     {
         // nEnbs, nUes, nDBearers, celist, name, useUdp, sched, admitHo, idealRrc
         AddTestCase(new LteX2HandoverMeasuresTestCase(2,
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/mesh/CMakeLists.txt ns-3.40/src/mesh/CMakeLists.txt
--- ns-3.39/src/mesh/CMakeLists.txt	2023-07-05 14:23:48.029428000 -0700
+++ ns-3.40/src/mesh/CMakeLists.txt	2023-09-27 13:30:37.830839600 -0700
@@ -68,7 +68,6 @@
   LIBRARIES_TO_LINK
     ${libinternet}
     ${libwifi}
-    ${libapplications}
   TEST_SOURCES
     test/dot11s/dot11s-test-suite.cc
     test/dot11s/hwmp-proactive-regression.cc
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/mesh/examples/mesh.cc ns-3.40/src/mesh/examples/mesh.cc
--- ns-3.39/src/mesh/examples/mesh.cc	2023-07-05 14:23:48.029428000 -0700
+++ ns-3.40/src/mesh/examples/mesh.cc	2023-09-27 13:30:37.834839600 -0700
@@ -336,7 +336,7 @@
 MeshTest::Report()
 {
     unsigned n(0);
-    for (NetDeviceContainer::Iterator i = meshDevices.Begin(); i != meshDevices.End(); ++i, ++n)
+    for (auto i = meshDevices.Begin(); i != meshDevices.End(); ++i, ++n)
     {
         std::ostringstream os;
         os << "mp-report-" << n << ".xml";
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/mesh/helper/dot11s/dot11s-installer.cc ns-3.40/src/mesh/helper/dot11s/dot11s-installer.cc
--- ns-3.39/src/mesh/helper/dot11s/dot11s-installer.cc	2023-07-05 14:23:48.029428000 -0700
+++ ns-3.40/src/mesh/helper/dot11s/dot11s-installer.cc	2023-09-27 13:30:37.834839600 -0700
@@ -16,7 +16,7 @@
  *
  * Authors: Kirill Andreev <andreev@iitp.ru>
  */
-#include "ns3/dot11s-installer.h"
+#include "dot11s-installer.h"
 
 #include "ns3/hwmp-protocol.h"
 #include "ns3/mesh-wifi-interface-mac.h"
@@ -92,7 +92,7 @@
     mp->Report(os);
 
     std::vector<Ptr<NetDevice>> ifaces = mp->GetInterfaces();
-    for (std::vector<Ptr<NetDevice>>::const_iterator i = ifaces.begin(); i != ifaces.end(); ++i)
+    for (auto i = ifaces.begin(); i != ifaces.end(); ++i)
     {
         Ptr<WifiNetDevice> device = (*i)->GetObject<WifiNetDevice>();
         NS_ASSERT(device);
@@ -115,7 +115,7 @@
     mp->ResetStats();
 
     std::vector<Ptr<NetDevice>> ifaces = mp->GetInterfaces();
-    for (std::vector<Ptr<NetDevice>>::const_iterator i = ifaces.begin(); i != ifaces.end(); ++i)
+    for (auto i = ifaces.begin(); i != ifaces.end(); ++i)
     {
         Ptr<WifiNetDevice> device = (*i)->GetObject<WifiNetDevice>();
         NS_ASSERT(device);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/mesh/helper/flame/flame-installer.cc ns-3.40/src/mesh/helper/flame/flame-installer.cc
--- ns-3.39/src/mesh/helper/flame/flame-installer.cc	2023-07-05 14:23:48.029428000 -0700
+++ ns-3.40/src/mesh/helper/flame/flame-installer.cc	2023-09-27 13:30:37.834839600 -0700
@@ -17,7 +17,7 @@
  * Authors: Kirill Andreev <andreev@iitp.ru>
  */
 
-#include "ns3/flame-installer.h"
+#include "flame-installer.h"
 
 #include "ns3/flame-protocol.h"
 #include "ns3/mesh-wifi-interface-mac.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/mesh/helper/mesh-helper.cc ns-3.40/src/mesh/helper/mesh-helper.cc
--- ns-3.39/src/mesh/helper/mesh-helper.cc	2023-07-05 14:23:48.029428000 -0700
+++ ns-3.40/src/mesh/helper/mesh-helper.cc	2023-09-27 13:30:37.834839600 -0700
@@ -64,7 +64,7 @@
 {
     NetDeviceContainer devices;
     NS_ASSERT(m_stack);
-    for (NodeContainer::Iterator i = c.Begin(); i != c.End(); ++i)
+    for (auto i = c.Begin(); i != c.End(); ++i)
     {
         Ptr<Node> node = *i;
         // Create a mesh point device
@@ -179,7 +179,7 @@
 {
     int64_t currentStream = stream;
     Ptr<NetDevice> netDevice;
-    for (NetDeviceContainer::Iterator i = c.Begin(); i != c.End(); ++i)
+    for (auto i = c.Begin(); i != c.End(); ++i)
     {
         netDevice = (*i);
         Ptr<MeshPointDevice> mpd = DynamicCast<MeshPointDevice>(netDevice);
@@ -190,7 +190,7 @@
             currentStream += mpd->AssignStreams(currentStream);
             // To access, we need the underlying WifiNetDevices
             std::vector<Ptr<NetDevice>> ifaces = mpd->GetInterfaces();
-            for (std::vector<Ptr<NetDevice>>::iterator i = ifaces.begin(); i != ifaces.end(); i++)
+            for (auto i = ifaces.begin(); i != ifaces.end(); i++)
             {
                 wifi = DynamicCast<WifiNetDevice>(*i);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/mesh/helper/mesh-helper.h ns-3.40/src/mesh/helper/mesh-helper.h
--- ns-3.39/src/mesh/helper/mesh-helper.h	2023-07-05 14:23:48.029428000 -0700
+++ ns-3.40/src/mesh/helper/mesh-helper.h	2023-09-27 13:30:37.834839600 -0700
@@ -21,7 +21,8 @@
 #ifndef MESH_HELPER_H
 #define MESH_HELPER_H
 
-#include "ns3/mesh-stack-installer.h"
+#include "mesh-stack-installer.h"
+
 #include "ns3/object-factory.h"
 #include "ns3/qos-utils.h"
 #include "ns3/wifi-standards.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/mesh/helper/mesh-stack-installer.cc ns-3.40/src/mesh/helper/mesh-stack-installer.cc
--- ns-3.39/src/mesh/helper/mesh-stack-installer.cc	2023-07-05 14:23:48.029428000 -0700
+++ ns-3.40/src/mesh/helper/mesh-stack-installer.cc	2023-09-27 13:30:37.834839600 -0700
@@ -17,7 +17,7 @@
  * Author: Peter D. Barnes, Jr. <pdbarnes@llnl.gov>
  */
 
-#include "ns3/mesh-stack-installer.h"
+#include "mesh-stack-installer.h"
 
 namespace ns3
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/mesh/model/dot11s/hwmp-protocol.cc ns-3.40/src/mesh/model/dot11s/hwmp-protocol.cc
--- ns-3.39/src/mesh/model/dot11s/hwmp-protocol.cc	2023-07-05 14:23:48.033428200 -0700
+++ ns-3.40/src/mesh/model/dot11s/hwmp-protocol.cc	2023-09-27 13:30:37.834839600 -0700
@@ -201,9 +201,7 @@
 HwmpProtocol::DoDispose()
 {
     NS_LOG_FUNCTION(this);
-    for (std::map<Mac48Address, PreqEvent>::iterator i = m_preqTimeouts.begin();
-         i != m_preqTimeouts.end();
-         i++)
+    for (auto i = m_preqTimeouts.begin(); i != m_preqTimeouts.end(); i++)
     {
         i->second.preqTimeout.Cancel();
     }
@@ -263,14 +261,10 @@
         m_stats.txBytes += packet->GetSize();
         // channel IDs where we have already sent broadcast:
         std::vector<uint16_t> channels;
-        for (HwmpProtocolMacMap::const_iterator plugin = m_interfaces.begin();
-             plugin != m_interfaces.end();
-             plugin++)
+        for (auto plugin = m_interfaces.begin(); plugin != m_interfaces.end(); plugin++)
         {
             bool shouldSend = true;
-            for (std::vector<uint16_t>::const_iterator chan = channels.begin();
-                 chan != channels.end();
-                 chan++)
+            for (auto chan = channels.begin(); chan != channels.end(); chan++)
             {
                 if ((*chan) == plugin->second->GetChannelId())
                 {
@@ -283,9 +277,7 @@
             }
             channels.push_back(plugin->second->GetChannelId());
             std::vector<Mac48Address> receivers = GetBroadcastReceivers(plugin->first);
-            for (std::vector<Mac48Address>::const_iterator i = receivers.begin();
-                 i != receivers.end();
-                 i++)
+            for (auto i = receivers.begin(); i != receivers.end(); i++)
             {
                 Ptr<Packet> packetCopy = packet->Copy();
                 //
@@ -396,8 +388,7 @@
             dst_seqno = result.seqnum;
         }
         m_stats.initiatedPreq++;
-        for (HwmpProtocolMacMap::const_iterator i = m_interfaces.begin(); i != m_interfaces.end();
-             i++)
+        for (auto i = m_interfaces.begin(); i != m_interfaces.end(); i++)
         {
             i->second->RequestDestination(destination, originator_seqno, dst_seqno);
         }
@@ -433,8 +424,7 @@
     NS_LOG_FUNCTION(this << from << interface << fromMp << metric);
     preq.IncrementMetric(metric);
     // acceptance cretirea:
-    std::map<Mac48Address, std::pair<uint32_t, uint32_t>>::const_iterator i =
-        m_hwmpSeqnoMetricDatabase.find(preq.GetOriginatorAddress());
+    auto i = m_hwmpSeqnoMetricDatabase.find(preq.GetOriginatorAddress());
     bool freshInfo(true);
     if (i != m_hwmpSeqnoMetricDatabase.end())
     {
@@ -501,9 +491,7 @@
         m_routeChangeTraceSource(rChange);
         ReactivePathResolved(fromMp);
     }
-    for (std::vector<Ptr<DestinationAddressUnit>>::const_iterator i = destinations.begin();
-         i != destinations.end();
-         i++)
+    for (auto i = destinations.begin(); i != destinations.end(); i++)
     {
         if ((*i)->GetDestinationAddress() == Mac48Address::GetBroadcast())
         {
@@ -603,7 +591,7 @@
     }
     // Forward PREQ to all interfaces:
     NS_LOG_DEBUG("I am " << GetAddress() << "retransmitting PREQ:" << preq);
-    for (HwmpProtocolMacMap::const_iterator i = m_interfaces.begin(); i != m_interfaces.end(); i++)
+    for (auto i = m_interfaces.begin(); i != m_interfaces.end(); i++)
     {
         Time forwardingDelay = GetMeshPoint()->GetForwardingDelay();
         NS_LOG_DEBUG("Forwarding PREQ from " << from << " with delay "
@@ -622,8 +610,7 @@
     NS_LOG_FUNCTION(this << from << interface << fromMp << metric);
     prep.IncrementMetric(metric);
     // acceptance cretirea:
-    std::map<Mac48Address, std::pair<uint32_t, uint32_t>>::const_iterator i =
-        m_hwmpSeqnoMetricDatabase.find(prep.GetOriginatorAddress());
+    auto i = m_hwmpSeqnoMetricDatabase.find(prep.GetOriginatorAddress());
     bool freshInfo(true);
     uint32_t sequence = prep.GetDestinationSeqNumber();
     if (i != m_hwmpSeqnoMetricDatabase.end())
@@ -711,7 +698,7 @@
         return;
     }
     // Forward PREP
-    HwmpProtocolMacMap::const_iterator prep_sender = m_interfaces.find(result.ifIndex);
+    auto prep_sender = m_interfaces.find(result.ifIndex);
     NS_ASSERT(prep_sender != m_interfaces.end());
     Time forwardingDelay = GetMeshPoint()->GetForwardingDelay();
     NS_LOG_DEBUG("Forwarding PREP from " << from << " with delay " << forwardingDelay.As(Time::US));
@@ -768,7 +755,7 @@
     prep.SetMetric(initMetric);
     prep.SetOriginatorAddress(src);
     prep.SetOriginatorSeqNumber(originatorDsn);
-    HwmpProtocolMacMap::const_iterator prep_sender = m_interfaces.find(interface);
+    auto prep_sender = m_interfaces.find(interface);
     NS_ASSERT(prep_sender != m_interfaces.end());
     prep_sender->second->SendPrep(prep, retransmitter);
     m_stats.initiatedPrep++;
@@ -780,8 +767,7 @@
     NS_LOG_FUNCTION(this << mp);
     m_mp = mp;
     std::vector<Ptr<NetDevice>> interfaces = mp->GetInterfaces();
-    for (std::vector<Ptr<NetDevice>>::const_iterator i = interfaces.begin(); i != interfaces.end();
-         i++)
+    for (auto i = interfaces.begin(); i != interfaces.end(); i++)
     {
         // Checking for compatible net device
         Ptr<WifiNetDevice> wifiNetDev = (*i)->GetObject<WifiNetDevice>();
@@ -841,8 +827,7 @@
         NS_LOG_DEBUG("Dropping seqno " << seqno << "; from self");
         return true;
     }
-    std::map<Mac48Address, uint32_t, std::less<Mac48Address>>::const_iterator i =
-        m_lastDataSeqno.find(source);
+    const auto i = m_lastDataSeqno.find(source);
     if (i == m_lastDataSeqno.end())
     {
         m_lastDataSeqno[source] = seqno;
@@ -889,7 +874,7 @@
 HwmpProtocol::InitiatePathError(PathError perr)
 {
     NS_LOG_FUNCTION(this);
-    for (HwmpProtocolMacMap::const_iterator i = m_interfaces.begin(); i != m_interfaces.end(); i++)
+    for (auto i = m_interfaces.begin(); i != m_interfaces.end(); i++)
     {
         std::vector<Mac48Address> receivers_for_interface;
         for (unsigned int j = 0; j < perr.receivers.size(); j++)
@@ -907,7 +892,7 @@
 HwmpProtocol::ForwardPathError(PathError perr)
 {
     NS_LOG_FUNCTION(this);
-    for (HwmpProtocolMacMap::const_iterator i = m_interfaces.begin(); i != m_interfaces.end(); i++)
+    for (auto i = m_interfaces.begin(); i != m_interfaces.end(); i++)
     {
         std::vector<Mac48Address> receivers_for_interface;
         for (unsigned int j = 0; j < perr.receivers.size(); j++)
@@ -1021,7 +1006,7 @@
     NS_LOG_FUNCTION(this << dst);
     QueuedPacket retval;
     retval.pkt = nullptr;
-    for (std::vector<QueuedPacket>::iterator i = m_rqueue.begin(); i != m_rqueue.end(); i++)
+    for (auto i = m_rqueue.begin(); i != m_rqueue.end(); i++)
     {
         if ((*i).dst == dst)
         {
@@ -1051,7 +1036,7 @@
 HwmpProtocol::ReactivePathResolved(Mac48Address dst)
 {
     NS_LOG_FUNCTION(this << dst);
-    std::map<Mac48Address, PreqEvent>::iterator i = m_preqTimeouts.find(dst);
+    auto i = m_preqTimeouts.find(dst);
     if (i != m_preqTimeouts.end())
     {
         m_routeDiscoveryTimeCallback(Simulator::Now() - i->second.whenScheduled);
@@ -1106,7 +1091,7 @@
 HwmpProtocol::ShouldSendPreq(Mac48Address dst)
 {
     NS_LOG_FUNCTION(this << dst);
-    std::map<Mac48Address, PreqEvent>::const_iterator i = m_preqTimeouts.find(dst);
+    auto i = m_preqTimeouts.find(dst);
     if (i == m_preqTimeouts.end())
     {
         m_preqTimeouts[dst].preqTimeout =
@@ -1132,7 +1117,7 @@
     }
     if (result.retransmitter != Mac48Address::GetBroadcast())
     {
-        std::map<Mac48Address, PreqEvent>::iterator i = m_preqTimeouts.find(dst);
+        auto i = m_preqTimeouts.find(dst);
         NS_ASSERT(i != m_preqTimeouts.end());
         m_preqTimeouts.erase(i);
         return;
@@ -1152,7 +1137,7 @@
                          HwmpRtable::MAX_METRIC);
             packet = DequeueFirstPacketByDst(dst);
         }
-        std::map<Mac48Address, PreqEvent>::iterator i = m_preqTimeouts.find(dst);
+        auto i = m_preqTimeouts.find(dst);
         NS_ASSERT(i != m_preqTimeouts.end());
         m_routeDiscoveryTimeCallback(Simulator::Now() - i->second.whenScheduled);
         m_preqTimeouts.erase(i);
@@ -1161,7 +1146,7 @@
     numOfRetry++;
     uint32_t originator_seqno = GetNextHwmpSeqno();
     uint32_t dst_seqno = m_rtable->LookupReactiveExpired(dst).seqnum;
-    for (HwmpProtocolMacMap::const_iterator i = m_interfaces.begin(); i != m_interfaces.end(); i++)
+    for (auto i = m_interfaces.begin(); i != m_interfaces.end(); i++)
     {
         i->second->RequestDestination(dst, originator_seqno, dst_seqno);
     }
@@ -1204,7 +1189,7 @@
     preq.SetOriginatorAddress(GetAddress());
     preq.SetPreqID(GetNextPreqId());
     preq.SetOriginatorSeqNumber(GetNextHwmpSeqno());
-    for (HwmpProtocolMacMap::const_iterator i = m_interfaces.begin(); i != m_interfaces.end(); i++)
+    for (auto i = m_interfaces.begin(); i != m_interfaces.end(); i++)
     {
         i->second->SendPreq(preq);
     }
@@ -1352,9 +1337,7 @@
        << "doFlag=\"" << m_doFlag << "\"" << std::endl
        << "rfFlag=\"" << m_rfFlag << "\">" << std::endl;
     m_stats.Print(os);
-    for (HwmpProtocolMacMap::const_iterator plugin = m_interfaces.begin();
-         plugin != m_interfaces.end();
-         plugin++)
+    for (auto plugin = m_interfaces.begin(); plugin != m_interfaces.end(); plugin++)
     {
         plugin->second->Report(os);
     }
@@ -1366,9 +1349,7 @@
 {
     NS_LOG_FUNCTION(this);
     m_stats = Statistics();
-    for (HwmpProtocolMacMap::const_iterator plugin = m_interfaces.begin();
-         plugin != m_interfaces.end();
-         plugin++)
+    for (auto plugin = m_interfaces.begin(); plugin != m_interfaces.end(); plugin++)
     {
         plugin->second->ResetStats();
     }
